/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.classicalb.core.preparser.lexer;

import java.io.*;
import java.util.*;
import de.be4.classicalb.core.preparser.node.*;
import de.hhu.stups.sablecc.patch.*;


@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.NORMAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;

	private IToken tok;

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return this.token;
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = this.token;
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NO_DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.NO_DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITION_FILE; break;
                                case 3: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.DEFINITION_FILE; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  String text,   int line,   int pos) { return new TComment(text, line, pos); }
    Token new1(  String text,   int line,   int pos) { return new TCommentEnd(text, line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TCommentContent(text, line, pos); }
    Token new3(  int line,   int pos) { return new TDefinitions(line, pos); }
    Token new4(  String text,   int line,   int pos) { return new TOtherClauseBegin(text, line, pos); }
    Token new5(  String text,   int line,   int pos) { return new TEndMachine(text, line, pos); }
    Token new6(  int line,   int pos) { return new TKwDefinitions(line, pos); }
    Token new7(  String text,   int line,   int pos) { return new TKwPrefix(text, line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TNoDefSomething(text, line, pos); }
    Token new9(  String text,   int line,   int pos) { return new TIdentifierLiteral(text, line, pos); }
    Token new10(  int line,   int pos) { return new TLeftPar(line, pos); }
    Token new11(  int line,   int pos) { return new TRightPar(line, pos); }
    Token new12(  int line,   int pos) { return new TComma(line, pos); }
    Token new13(  int line,   int pos) { return new TBeginDefBody(line, pos); }
    Token new14(  String text,   int line,   int pos) { return new TRhsBody(text, line, pos); }
    Token new15(  String text,   int line,   int pos) { return new TBeginNesting(text, line, pos); }
    Token new16(  String text,   int line,   int pos) { return new TEndNesting(text, line, pos); }
    Token new17(  String text,   int line,   int pos) { return new TRhsIdentifier(text, line, pos); }
    Token new18(  String text,   int line,   int pos) { return new TSemicolon(text, line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TDoubleQuotation(text, line, pos); }
    Token new20(  String text,   int line,   int pos) { return new TFilename(text, line, pos); }
    Token new21(  String text,   int line,   int pos) { return new TSomething(text, line, pos); }
    Token new22(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{0, 32, 1}, {33, 34, 2}, {35, 35, 3}, {36, 46, 2}, {47, 47, 4}, {48, 64, 2}, {65, 65, 5}, {66, 66, 2}, {67, 67, 6}, {68, 68, 7}, {69, 69, 8}, {70, 72, 2}, {73, 73, 9}, {74, 75, 2}, {76, 76, 10}, {77, 77, 11}, {78, 78, 2}, {79, 79, 12}, {80, 80, 13}, {81, 81, 2}, {82, 82, 14}, {83, 83, 15}, {84, 84, 2}, {85, 85, 16}, {86, 86, 17}, {87, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 32, 18}, {127, 160, 18}, {8206, 8207, 18}, {8232, 8233, 18}, },
            {},
            {{65, 65, 19}, {67, 67, 20}, {68, 68, 21}, {69, 69, 22}, {73, 73, 23}, {76, 76, 24}, {79, 79, 25}, {80, 80, 26}, {82, 82, 27}, {83, 83, 28}, {85, 85, 29}, {86, 86, 30}, },
            {{42, 42, 31}, },
            {{66, 66, 32}, {83, 83, 33}, },
            {{79, 79, 34}, },
            {{69, 69, 35}, },
            {{78, 78, 36}, {86, 86, 37}, },
            {{77, 77, 38}, {78, 78, 39}, },
            {{79, 79, 40}, },
            {{65, 65, 41}, {79, 79, 42}, },
            {{80, 80, 43}, },
            {{82, 82, 44}, },
            {{69, 69, 45}, },
            {{69, 69, 46}, {89, 89, 47}, },
            {{83, 83, 48}, },
            {{65, 65, 49}, },
            {{0, 8233, -3}, },
            {{66, 66, 50}, {83, 83, 51}, },
            {{79, 79, 52}, },
            {{69, 69, 53}, },
            {{86, 86, 54}, {88, 88, 55}, },
            {{77, 77, 56}, {78, 78, 57}, },
            {{79, 79, 58}, },
            {{80, 80, 59}, },
            {{82, 82, 60}, },
            {{69, 69, 61}, },
            {{69, 69, 62}, {85, 85, 63}, },
            {{83, 83, 64}, },
            {{65, 65, 65}, },
            {},
            {{83, 83, 66}, },
            {{83, 83, 67}, },
            {{78, 78, 68}, },
            {{70, 70, 69}, },
            {{68, 68, 70}, },
            {{69, 69, 71}, },
            {{80, 80, 72}, },
            {{67, 67, 73}, {73, 73, 74}, {86, 86, 75}, },
            {{67, 67, 76}, },
            {{67, 67, 77}, },
            {{68, 68, 78}, },
            {{69, 69, 79}, },
            {{79, 79, 80}, },
            {{70, 70, 81}, },
            {{69, 69, 82}, {84, 84, 83}, },
            {{83, 83, 84}, },
            {{69, 69, 85}, },
            {{76, 76, 86}, {82, 82, 87}, },
            {{83, 83, 88}, },
            {{83, 83, 89}, },
            {{78, 78, 90}, },
            {{70, 70, 91}, },
            {{69, 69, 92}, },
            {{80, 80, 93}, },
            {{80, 80, 94}, },
            {{67, 67, 95}, {73, 73, 96}, {86, 86, 97}, },
            {{67, 67, 98}, },
            {{69, 69, 99}, },
            {{69, 69, 100}, {79, 79, 101}, },
            {{70, 70, 102}, },
            {{69, 69, 103}, {84, 84, 104}, },
            {{66, 66, 105}, },
            {{69, 69, 106}, },
            {{76, 76, 107}, {82, 82, 108}, },
            {{84, 84, 109}, },
            {{69, 69, 110}, },
            {{67, 67, 111}, {83, 83, 112}, },
            {{73, 73, 113}, },
            {},
            {{78, 78, 114}, },
            {{76, 76, 115}, {79, 79, 116}, },
            {{76, 76, 117}, },
            {{84, 84, 118}, },
            {{65, 65, 119}, },
            {{65, 65, 120}, },
            {{72, 72, 121}, },
            {{69, 69, 122}, },
            {{82, 82, 123}, },
            {{77, 77, 124}, {80, 80, 125}, },
            {{73, 73, 126}, },
            {{83, 83, 127}, },
            {{83, 83, 128}, },
            {{84, 84, 129}, },
            {{83, 83, 130}, },
            {{85, 85, 131}, },
            {{73, 73, 132}, },
            {{84, 84, 133}, },
            {{69, 69, 134}, },
            {{67, 67, 135}, {83, 83, 136}, },
            {{73, 73, 137}, },
            {{78, 78, 138}, },
            {{82, 82, 139}, },
            {{76, 76, 140}, {79, 79, 141}, },
            {{76, 76, 142}, },
            {{84, 84, 143}, },
            {{65, 65, 144}, },
            {{65, 65, 145}, },
            {{82, 82, 146}, },
            {{68, 68, 147}, },
            {{77, 77, 148}, {80, 80, 149}, },
            {{73, 73, 150}, },
            {{83, 83, 151}, },
            {{83, 83, 152}, },
            {{83, 83, 153}, },
            {{83, 83, 154}, },
            {{85, 85, 155}, },
            {{73, 73, 156}, },
            {{82, 82, 157}, },
            {{82, 82, 158}, },
            {{82, 82, 159}, },
            {{84, 84, 160}, },
            {{78, 78, 161}, },
            {{84, 84, 162}, },
            {{69, 69, 163}, },
            {{82, 82, 164}, },
            {{85, 85, 165}, },
            {{73, 73, 166}, },
            {{82, 82, 167}, },
            {{76, 76, 168}, },
            {{73, 73, 169}, },
            {{76, 76, 170}, },
            {{65, 65, 171}, },
            {{79, 79, 172}, },
            {{69, 69, 173}, },
            {{78, 78, 174}, },
            {},
            {},
            {{69, 69, 175}, },
            {},
            {{69, 69, 176}, },
            {{65, 65, 177}, },
            {{82, 82, 178}, },
            {{82, 82, 179}, },
            {{82, 82, 180}, },
            {{84, 84, 181}, },
            {{78, 78, 182}, },
            {{84, 84, 183}, },
            {{69, 69, 184}, },
            {{69, 69, 185}, },
            {{82, 82, 186}, },
            {{85, 85, 187}, },
            {{73, 73, 188}, },
            {{82, 82, 189}, },
            {{76, 76, 190}, },
            {{65, 65, 191}, },
            {{73, 73, 192}, },
            {{79, 79, 193}, },
            {{69, 69, 194}, },
            {{78, 78, 195}, },
            {},
            {},
            {{84, 84, 196}, },
            {},
            {{69, 69, 197}, },
            {{65, 65, 198}, },
            {{65, 65, 199}, },
            {{84, 84, 200}, },
            {{69, 69, 201}, },
            {{65, 65, 202}, {82, 82, 203}, },
            {{73, 73, 204}, },
            {{83, 83, 205}, },
            {{77, 77, 206}, },
            {{84, 84, 207}, },
            {{68, 68, 208}, },
            {{65, 65, 209}, },
            {{73, 73, 210}, },
            {{95, 95, 211}, },
            {{78, 78, 212}, },
            {},
            {{84, 84, 213}, },
            {{84, 84, 214}, },
            {{82, 82, 215}, },
            {{69, 69, 216}, },
            {{77, 77, 217}, },
            {{83, 83, 218}, },
            {{66, 66, 219}, },
            {{65, 65, 220}, },
            {{84, 84, 221}, },
            {{69, 69, 222}, },
            {{65, 65, 223}, {82, 82, 224}, },
            {{73, 73, 225}, },
            {{83, 83, 226}, },
            {{83, 83, 227}, },
            {{77, 77, 228}, },
            {{84, 84, 229}, },
            {{68, 68, 230}, },
            {{65, 65, 231}, },
            {{73, 73, 232}, },
            {{95, 95, 233}, },
            {{84, 84, 234}, },
            {{67, 67, 235}, },
            {{84, 84, 236}, },
            {{82, 82, 237}, },
            {{69, 69, 238}, },
            {{73, 73, 239}, },
            {{83, 83, 240}, },
            {{66, 66, 241}, },
            {{67, 67, 242}, },
            {{73, 73, 243}, },
            {{84, 84, 244}, },
            {{78, 78, 245}, },
            {{65, 65, 246}, },
            {{84, 84, 247}, },
            {},
            {{69, 69, 248}, },
            {{83, 83, 249}, },
            {{69, 69, 250}, },
            {{76, 76, 251}, },
            {{65, 65, 252}, },
            {{79, 79, 253}, },
            {{69, 69, 254}, },
            {{73, 73, 255}, },
            {{69, 69, 256}, },
            {{84, 84, 257}, },
            {{77, 77, 258}, {83, 83, 259}, },
            {},
            {},
            {{76, 76, 260}, },
            {{67, 67, 261}, },
            {{73, 73, 262}, },
            {{84, 84, 263}, },
            {{78, 78, 264}, },
            {{65, 65, 265}, },
            {{84, 84, 266}, },
            {},
            {{83, 83, 267}, },
            {{69, 69, 268}, },
            {{83, 83, 269}, },
            {{69, 69, 270}, },
            {{76, 76, 271}, },
            {{65, 65, 272}, },
            {{79, 79, 273}, },
            {{73, 73, 274}, },
            {{65, 65, 275}, },
            {{69, 69, 276}, },
            {{84, 84, 277}, },
            {{83, 83, 278}, },
            {{84, 84, 279}, },
            {},
            {{76, 76, 280}, },
            {{84, 84, 281}, },
            {{79, 79, 282}, },
            {{69, 69, 283}, },
            {{84, 84, 284}, },
            {{73, 73, 285}, },
            {{73, 73, 286}, },
            {{78, 78, 287}, },
            {},
            {{83, 83, 288}, },
            {{73, 73, 289}, },
            {{78, 78, 290}, },
            {{80, 80, 291}, },
            {},
            {{79, 79, 292}, },
            {{83, 83, 293}, },
            {{73, 73, 294}, },
            {{69, 69, 295}, },
            {},
            {{69, 69, 296}, },
            {{84, 84, 297}, },
            {{79, 79, 298}, },
            {{69, 69, 299}, },
            {{84, 84, 300}, },
            {{73, 73, 301}, },
            {{73, 73, 302}, },
            {{73, 73, 303}, },
            {{78, 78, 304}, },
            {},
            {{83, 83, 305}, },
            {{73, 73, 306}, },
            {{78, 78, 307}, },
            {{80, 80, 308}, },
            {{79, 79, 309}, },
            {{84, 84, 310}, },
            {{83, 83, 311}, },
            {{73, 73, 312}, },
            {},
            {{85, 85, 313}, },
            {{69, 69, 314}, },
            {{95, 95, 315}, },
            {{78, 78, 316}, },
            {{95, 95, 317}, },
            {{83, 83, 318}, },
            {{78, 78, 319}, },
            {{79, 79, 320}, },
            {{84, 84, 321}, },
            {},
            {{83, 83, 322}, {90, 90, 323}, },
            {{84, 84, 324}, },
            {{69, 69, 325}, },
            {{78, 78, 326}, },
            {},
            {{69, 69, 327}, },
            {{78, 78, 328}, },
            {{83, 83, 329}, },
            {{95, 95, 330}, },
            {{78, 78, 331}, },
            {{95, 95, 332}, },
            {{83, 83, 333}, },
            {{78, 78, 334}, },
            {{79, 79, 335}, },
            {{79, 79, 336}, },
            {{84, 84, 337}, },
            {},
            {{83, 83, 338}, {90, 90, 339}, },
            {{84, 84, 340}, },
            {{69, 69, 341}, },
            {{78, 78, 342}, },
            {{69, 69, 343}, },
            {},
            {{69, 69, 344}, },
            {{84, 84, 345}, },
            {{83, 83, 346}, },
            {{67, 67, 347}, {86, 86, 348}, },
            {{83, 83, 349}, },
            {{67, 67, 350}, {86, 86, 351}, },
            {},
            {{84, 84, 352}, },
            {{78, 78, 353}, },
            {{65, 65, 354}, },
            {{65, 65, 355}, },
            {{65, 65, 356}, },
            {},
            {{82, 82, 357}, },
            {{83, 83, 358}, },
            {{83, 83, 359}, },
            {{84, 84, 360}, },
            {},
            {{67, 67, 361}, {86, 86, 362}, },
            {{83, 83, 363}, },
            {{67, 67, 364}, {86, 86, 365}, },
            {},
            {{84, 84, 366}, },
            {{78, 78, 367}, },
            {{78, 78, 368}, },
            {{65, 65, 369}, },
            {{65, 65, 370}, },
            {{65, 65, 371}, },
            {},
            {{82, 82, 372}, },
            {{83, 83, 373}, },
            {},
            {{83, 83, 374}, },
            {{73, 73, 375}, },
            {},
            {{79, 79, 376}, },
            {{65, 65, 377}, },
            {},
            {{79, 79, 378}, },
            {{65, 65, 379}, },
            {{83, 83, 380}, },
            {{83, 83, 381}, },
            {{84, 84, 382}, },
            {{84, 84, 383}, },
            {{84, 84, 384}, },
            {{65, 65, 385}, },
            {},
            {},
            {},
            {{79, 79, 386}, },
            {{65, 65, 387}, },
            {},
            {{79, 79, 388}, },
            {{65, 65, 389}, },
            {{83, 83, 390}, },
            {{83, 83, 391}, },
            {},
            {{84, 84, 392}, },
            {{84, 84, 393}, },
            {{84, 84, 394}, },
            {{65, 65, 395}, },
            {},
            {},
            {{79, 79, 396}, },
            {{78, 78, 397}, },
            {{82, 82, 398}, },
            {{78, 78, 399}, },
            {{82, 82, 400}, },
            {},
            {},
            {{73, 73, 401}, },
            {{73, 73, 402}, },
            {{73, 73, 403}, },
            {{84, 84, 404}, },
            {{78, 78, 405}, },
            {{82, 82, 406}, },
            {{78, 78, 407}, },
            {{82, 82, 408}, },
            {},
            {},
            {{73, 73, 409}, },
            {{73, 73, 410}, },
            {{73, 73, 411}, },
            {{84, 84, 412}, },
            {{78, 78, 413}, },
            {{83, 83, 414}, },
            {{73, 73, 415}, },
            {{83, 83, 416}, },
            {{73, 73, 417}, },
            {{79, 79, 418}, },
            {{79, 79, 419}, },
            {{79, 79, 420}, },
            {{73, 73, 421}, },
            {{83, 83, 422}, },
            {{73, 73, 423}, },
            {{83, 83, 424}, },
            {{73, 73, 425}, },
            {{79, 79, 426}, },
            {{79, 79, 427}, },
            {{79, 79, 428}, },
            {{73, 73, 429}, },
            {},
            {{84, 84, 430}, },
            {{65, 65, 431}, },
            {{84, 84, 432}, },
            {{65, 65, 433}, },
            {{78, 78, 434}, },
            {{78, 78, 435}, },
            {{78, 78, 436}, },
            {{79, 79, 437}, },
            {{84, 84, 438}, },
            {{65, 65, 439}, },
            {{84, 84, 440}, },
            {{65, 65, 441}, },
            {{78, 78, 442}, },
            {{78, 78, 443}, },
            {{78, 78, 444}, },
            {{79, 79, 445}, },
            {{65, 65, 446}, },
            {{66, 66, 447}, },
            {{65, 65, 448}, },
            {{66, 66, 449}, },
            {},
            {},
            {},
            {{78, 78, 450}, },
            {{65, 65, 451}, },
            {{66, 66, 452}, },
            {{65, 65, 453}, },
            {{66, 66, 454}, },
            {},
            {},
            {},
            {{78, 78, 455}, },
            {{78, 78, 456}, },
            {{76, 76, 457}, },
            {{78, 78, 458}, },
            {{76, 76, 459}, },
            {{83, 83, 460}, },
            {{78, 78, 461}, },
            {{76, 76, 462}, },
            {{78, 78, 463}, },
            {{76, 76, 464}, },
            {{83, 83, 465}, },
            {{84, 84, 466}, },
            {{69, 69, 467}, },
            {{84, 84, 468}, },
            {{69, 69, 469}, },
            {},
            {{84, 84, 470}, },
            {{69, 69, 471}, },
            {{84, 84, 472}, },
            {{69, 69, 473}, },
            {},
            {{83, 83, 474}, },
            {{83, 83, 475}, },
            {{83, 83, 476}, },
            {{83, 83, 477}, },
            {{83, 83, 478}, },
            {{83, 83, 479}, },
            {{83, 83, 480}, },
            {{83, 83, 481}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
        }
        { // DEFINITIONS
            {{0, 32, 1}, {34, 34, 2}, {40, 40, 3}, {41, 41, 4}, {44, 44, 5}, {47, 47, 6}, {59, 59, 7}, {61, 61, 8}, {65, 65, 9}, {66, 66, 10}, {67, 67, 11}, {68, 68, 10}, {69, 69, 12}, {70, 72, 10}, {73, 73, 13}, {74, 75, 10}, {76, 76, 14}, {77, 77, 15}, {78, 78, 10}, {79, 79, 16}, {80, 80, 17}, {81, 81, 10}, {82, 82, 18}, {83, 83, 19}, {84, 84, 10}, {85, 85, 20}, {86, 86, 21}, {87, 90, 10}, {97, 122, 22}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {{0, 32, 1}, {127, 8233, -2}, },
            {},
            {},
            {},
            {},
            {{42, 42, 23}, },
            {},
            {{61, 61, 24}, },
            {{48, 57, 25}, {65, 65, 26}, {66, 66, 27}, {67, 82, 26}, {83, 83, 28}, {84, 90, 26}, {95, 95, 29}, {97, 122, 30}, },
            {{48, 57, 25}, {65, 90, 26}, {95, 122, -11}, },
            {{48, 57, 25}, {65, 78, 26}, {79, 79, 31}, {80, 90, 26}, {95, 122, -11}, },
            {{48, 57, 25}, {65, 77, 26}, {78, 78, 32}, {79, 85, 26}, {86, 86, 33}, {87, 90, 26}, {95, 122, -11}, },
            {{48, 57, 25}, {65, 76, 26}, {77, 77, 34}, {78, 78, 35}, {79, 90, 26}, {95, 122, -11}, },
            {{48, 78, -13}, {79, 79, 36}, {80, 122, -13}, },
            {{48, 57, 25}, {65, 65, 37}, {66, 78, 26}, {79, 79, 38}, {80, 122, -13}, },
            {{48, 57, 25}, {65, 79, 26}, {80, 80, 39}, {81, 90, 26}, {95, 122, -11}, },
            {{48, 57, 25}, {65, 81, 26}, {82, 82, 40}, {83, 90, 26}, {95, 122, -11}, },
            {{48, 57, 25}, {65, 68, 26}, {69, 69, 41}, {70, 90, 26}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 42}, {70, 88, 26}, {89, 89, 43}, {90, 90, 26}, {95, 122, -11}, },
            {{48, 57, 25}, {65, 82, 26}, {83, 83, 44}, {84, 122, -11}, },
            {{48, 57, 25}, {65, 65, 45}, {66, 90, 26}, {95, 122, -11}, },
            {{48, 122, -12}, },
            {},
            {},
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 46}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 47}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 48}, {79, 122, -15}, },
            {{48, 57, 25}, {65, 67, 26}, {68, 68, 49}, {69, 90, 26}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 50}, {70, 122, -20}, },
            {{48, 79, -18}, {80, 80, 51}, {81, 122, -18}, },
            {{48, 57, 25}, {65, 66, 26}, {67, 67, 52}, {68, 72, 26}, {73, 73, 53}, {74, 85, 26}, {86, 86, 54}, {87, 122, -14}, },
            {{48, 66, -37}, {67, 67, 55}, {68, 90, 26}, {95, 122, -11}, },
            {{48, 66, -37}, {67, 67, 56}, {68, 122, -38}, },
            {{48, 67, -34}, {68, 68, 57}, {69, 122, -34}, },
            {{48, 68, -20}, {69, 69, 58}, {70, 122, -20}, },
            {{48, 78, -13}, {79, 79, 59}, {80, 122, -13}, },
            {{48, 57, 25}, {65, 69, 26}, {70, 70, 60}, {71, 90, 26}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 61}, {70, 83, 26}, {84, 84, 62}, {85, 90, 26}, {95, 122, -11}, },
            {{48, 82, -22}, {83, 83, 63}, {84, 122, -11}, },
            {{48, 68, -20}, {69, 69, 64}, {70, 122, -20}, },
            {{48, 57, 25}, {65, 75, 26}, {76, 76, 65}, {77, 81, 26}, {82, 82, 66}, {83, 122, -19}, },
            {{48, 57, 25}, {65, 83, 26}, {84, 84, 67}, {85, 122, -44}, },
            {{48, 68, -20}, {69, 69, 68}, {70, 122, -20}, },
            {{48, 66, -37}, {67, 67, 69}, {68, 82, 26}, {83, 83, 70}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 71}, {79, 122, -15}, },
            {{48, 75, -47}, {76, 76, 72}, {77, 78, 26}, {79, 79, 73}, {80, 122, -13}, },
            {{48, 75, -47}, {76, 76, 74}, {77, 90, 26}, {95, 122, -11}, },
            {{48, 83, -48}, {84, 84, 75}, {85, 122, -44}, },
            {{48, 57, 25}, {65, 65, 76}, {66, 122, -23}, },
            {{48, 57, 25}, {65, 65, 77}, {66, 122, -23}, },
            {{48, 57, 25}, {65, 71, 26}, {72, 72, 78}, {73, 90, 26}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 79}, {70, 122, -20}, },
            {{48, 81, -19}, {82, 82, 80}, {83, 122, -19}, },
            {{48, 76, -15}, {77, 77, 81}, {78, 79, 26}, {80, 80, 82}, {81, 122, -18}, },
            {{48, 57, 25}, {65, 72, 26}, {73, 73, 83}, {74, 90, 26}, {95, 122, -11}, },
            {{48, 82, -22}, {83, 83, 84}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 85}, {84, 122, -11}, },
            {{48, 83, -48}, {84, 84, 86}, {85, 122, -44}, },
            {{48, 82, -22}, {83, 83, 87}, {84, 122, -11}, },
            {{48, 57, 25}, {65, 84, 26}, {85, 85, 88}, {86, 90, 26}, {95, 122, -11}, },
            {{48, 72, -62}, {73, 73, 89}, {74, 122, -62}, },
            {{48, 81, -19}, {82, 82, 90}, {83, 122, -19}, },
            {{48, 81, -19}, {82, 82, 91}, {83, 122, -19}, },
            {{48, 81, -19}, {82, 82, 92}, {83, 122, -19}, },
            {{48, 83, -48}, {84, 84, 93}, {85, 122, -44}, },
            {{48, 83, -48}, {84, 84, 94}, {85, 122, -44}, },
            {{48, 68, -20}, {69, 69, 95}, {70, 122, -20}, },
            {{48, 81, -19}, {82, 82, 96}, {83, 122, -19}, },
            {{48, 84, -67}, {85, 85, 97}, {86, 122, -67}, },
            {{48, 72, -62}, {73, 73, 98}, {74, 122, -62}, },
            {{48, 81, -19}, {82, 82, 99}, {83, 122, -19}, },
            {{48, 75, -47}, {76, 76, 100}, {77, 122, -54}, },
            {{48, 72, -62}, {73, 73, 101}, {74, 122, -62}, },
            {{48, 75, -47}, {76, 76, 102}, {77, 122, -54}, },
            {{48, 57, 25}, {65, 65, 103}, {66, 122, -23}, },
            {{48, 78, -13}, {79, 79, 104}, {80, 122, -13}, },
            {{48, 68, -20}, {69, 69, 105}, {70, 122, -20}, },
            {{48, 77, -14}, {78, 78, 106}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 107}, {70, 122, -20}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 108}, {70, 122, -20}, },
            {{48, 57, 25}, {65, 65, 109}, {66, 122, -23}, },
            {{48, 57, 25}, {65, 65, 110}, {66, 122, -23}, },
            {{48, 83, -48}, {84, 84, 111}, {85, 122, -44}, },
            {{48, 68, -20}, {69, 69, 112}, {70, 122, -20}, },
            {{48, 57, 25}, {65, 65, 113}, {66, 81, 26}, {82, 82, 114}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 115}, {84, 122, -11}, },
            {{48, 76, -15}, {77, 77, 116}, {78, 90, 26}, {95, 122, -11}, },
            {{48, 83, -48}, {84, 84, 117}, {85, 122, -44}, },
            {{48, 67, -34}, {68, 68, 118}, {69, 122, -34}, },
            {{48, 57, 25}, {65, 65, 119}, {66, 122, -23}, },
            {{48, 72, -62}, {73, 73, 120}, {74, 122, -62}, },
            {{48, 90, -12}, {95, 95, 121}, {97, 122, 30}, },
            {{48, 77, -14}, {78, 78, 122}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 83, -48}, {84, 84, 123}, {85, 122, -44}, },
            {{48, 83, -48}, {84, 84, 124}, {85, 122, -44}, },
            {{48, 81, -19}, {82, 82, 125}, {83, 122, -19}, },
            {{48, 68, -20}, {69, 69, 126}, {70, 122, -20}, },
            {{48, 76, -15}, {77, 77, 127}, {78, 122, -97}, },
            {{48, 82, -22}, {83, 83, 128}, {84, 122, -11}, },
            {{48, 65, -11}, {66, 66, 129}, {67, 90, 26}, {95, 122, -11}, },
            {{48, 66, -37}, {67, 67, 130}, {68, 122, -38}, },
            {{48, 72, -62}, {73, 73, 131}, {74, 122, -62}, },
            {{48, 83, -48}, {84, 84, 132}, {85, 122, -44}, },
            {{48, 77, -14}, {78, 78, 133}, {79, 122, -15}, },
            {{48, 57, 25}, {65, 65, 134}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 135}, {70, 122, -20}, },
            {{48, 82, -22}, {83, 83, 136}, {84, 122, -11}, },
            {{48, 68, -20}, {69, 69, 137}, {70, 122, -20}, },
            {{48, 75, -47}, {76, 76, 138}, {77, 122, -54}, },
            {{48, 57, 25}, {65, 65, 139}, {66, 122, -23}, },
            {{48, 78, -13}, {79, 79, 140}, {80, 122, -13}, },
            {{48, 68, -20}, {69, 69, 141}, {70, 122, -20}, },
            {{48, 72, -62}, {73, 73, 142}, {74, 122, -62}, },
            {{48, 68, -20}, {69, 69, 143}, {70, 122, -20}, },
            {{48, 83, -48}, {84, 84, 144}, {85, 122, -44}, },
            {{48, 76, -15}, {77, 77, 145}, {78, 82, 26}, {83, 83, 146}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 75, -47}, {76, 76, 147}, {77, 122, -54}, },
            {{48, 83, -48}, {84, 84, 148}, {85, 122, -44}, },
            {{48, 78, -13}, {79, 79, 149}, {80, 122, -13}, },
            {{48, 68, -20}, {69, 69, 150}, {70, 122, -20}, },
            {{48, 83, -48}, {84, 84, 151}, {85, 122, -44}, },
            {{48, 72, -62}, {73, 73, 152}, {74, 122, -62}, },
            {{48, 77, -14}, {78, 78, 153}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 154}, {84, 122, -11}, },
            {{48, 72, -62}, {73, 73, 155}, {74, 122, -62}, },
            {{48, 77, -14}, {78, 78, 156}, {79, 122, -15}, },
            {{48, 79, -18}, {80, 80, 157}, {81, 122, -18}, },
            {{48, 122, -12}, },
            {{48, 78, -13}, {79, 79, 158}, {80, 122, -13}, },
            {{48, 82, -22}, {83, 83, 159}, {84, 122, -11}, },
            {{48, 72, -62}, {73, 73, 160}, {74, 122, -62}, },
            {{48, 68, -20}, {69, 69, 161}, {70, 122, -20}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 162}, {70, 122, -20}, },
            {{48, 90, -12}, {95, 95, 163}, {97, 122, 30}, },
            {{48, 77, -14}, {78, 78, 164}, {79, 122, -15}, },
            {{48, 90, -12}, {95, 95, 165}, {97, 122, 30}, },
            {{48, 82, -22}, {83, 83, 166}, {84, 122, -11}, },
            {{48, 77, -14}, {78, 78, 167}, {79, 122, -15}, },
            {{48, 83, -48}, {84, 84, 168}, {85, 122, -44}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 169}, {84, 89, 26}, {90, 90, 170}, {95, 122, -11}, },
            {{48, 83, -48}, {84, 84, 171}, {85, 122, -44}, },
            {{48, 68, -20}, {69, 69, 172}, {70, 122, -20}, },
            {{48, 77, -14}, {78, 78, 173}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 174}, {70, 122, -20}, },
            {{48, 77, -14}, {78, 78, 175}, {79, 122, -15}, },
            {{48, 82, -22}, {83, 83, 176}, {84, 122, -11}, },
            {{48, 66, -37}, {67, 67, 177}, {68, 85, 26}, {86, 86, 178}, {87, 122, -14}, },
            {{48, 82, -22}, {83, 83, 179}, {84, 122, -11}, },
            {{48, 66, -37}, {67, 67, 180}, {68, 85, 26}, {86, 86, 181}, {87, 122, -14}, },
            {{48, 122, -12}, },
            {{48, 83, -48}, {84, 84, 182}, {85, 122, -44}, },
            {{48, 57, 25}, {65, 65, 183}, {66, 122, -23}, },
            {{48, 57, 25}, {65, 65, 184}, {66, 122, -23}, },
            {{48, 57, 25}, {65, 65, 185}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 81, -19}, {82, 82, 186}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 187}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 188}, {84, 122, -11}, },
            {{48, 83, -48}, {84, 84, 189}, {85, 122, -44}, },
            {{48, 122, -12}, },
            {{48, 78, -13}, {79, 79, 190}, {80, 122, -13}, },
            {{48, 57, 25}, {65, 65, 191}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 78, -13}, {79, 79, 192}, {80, 122, -13}, },
            {{48, 57, 25}, {65, 65, 193}, {66, 122, -23}, },
            {{48, 82, -22}, {83, 83, 194}, {84, 122, -11}, },
            {{48, 83, -48}, {84, 84, 195}, {85, 122, -44}, },
            {{48, 83, -48}, {84, 84, 196}, {85, 122, -44}, },
            {{48, 83, -48}, {84, 84, 197}, {85, 122, -44}, },
            {{48, 57, 25}, {65, 65, 198}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 199}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 200}, {83, 122, -19}, },
            {{48, 77, -14}, {78, 78, 201}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 202}, {83, 122, -19}, },
            {{48, 122, -12}, },
            {{48, 72, -62}, {73, 73, 203}, {74, 122, -62}, },
            {{48, 72, -62}, {73, 73, 204}, {74, 122, -62}, },
            {{48, 72, -62}, {73, 73, 205}, {74, 122, -62}, },
            {{48, 83, -48}, {84, 84, 206}, {85, 122, -44}, },
            {{48, 82, -22}, {83, 83, 207}, {84, 122, -11}, },
            {{48, 72, -62}, {73, 73, 208}, {74, 122, -62}, },
            {{48, 82, -22}, {83, 83, 209}, {84, 122, -11}, },
            {{48, 72, -62}, {73, 73, 210}, {74, 122, -62}, },
            {{48, 78, -13}, {79, 79, 211}, {80, 122, -13}, },
            {{48, 78, -13}, {79, 79, 212}, {80, 122, -13}, },
            {{48, 78, -13}, {79, 79, 213}, {80, 122, -13}, },
            {{48, 72, -62}, {73, 73, 214}, {74, 122, -62}, },
            {{48, 83, -48}, {84, 84, 215}, {85, 122, -44}, },
            {{48, 57, 25}, {65, 65, 216}, {66, 122, -23}, },
            {{48, 83, -48}, {84, 84, 217}, {85, 122, -44}, },
            {{48, 57, 25}, {65, 65, 218}, {66, 122, -23}, },
            {{48, 77, -14}, {78, 78, 219}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 220}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 221}, {79, 122, -15}, },
            {{48, 78, -13}, {79, 79, 222}, {80, 122, -13}, },
            {{48, 57, 25}, {65, 65, 223}, {66, 122, -23}, },
            {{48, 65, -11}, {66, 66, 224}, {67, 122, -111}, },
            {{48, 57, 25}, {65, 65, 225}, {66, 122, -23}, },
            {{48, 65, -11}, {66, 66, 226}, {67, 122, -111}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 227}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 228}, {79, 122, -15}, },
            {{48, 75, -47}, {76, 76, 229}, {77, 122, -54}, },
            {{48, 77, -14}, {78, 78, 230}, {79, 122, -15}, },
            {{48, 75, -47}, {76, 76, 231}, {77, 122, -54}, },
            {{48, 82, -22}, {83, 83, 232}, {84, 122, -11}, },
            {{48, 83, -48}, {84, 84, 233}, {85, 122, -44}, },
            {{48, 68, -20}, {69, 69, 234}, {70, 122, -20}, },
            {{48, 83, -48}, {84, 84, 235}, {85, 122, -44}, },
            {{48, 68, -20}, {69, 69, 236}, {70, 122, -20}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 237}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 238}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 239}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 240}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
        }
        { // DEFINITIONS_RHS
            {{0, 32, 1}, {33, 33, 2}, {34, 34, 3}, {35, 39, 2}, {40, 40, 4}, {41, 41, 5}, {42, 46, 2}, {47, 47, 6}, {48, 58, 2}, {59, 59, 7}, {60, 64, 2}, {65, 65, 8}, {66, 66, 9}, {67, 67, 10}, {68, 68, 11}, {69, 69, 12}, {70, 72, 11}, {73, 73, 13}, {74, 75, 11}, {76, 76, 14}, {77, 77, 15}, {78, 78, 11}, {79, 79, 16}, {80, 80, 17}, {81, 81, 11}, {82, 82, 18}, {83, 83, 19}, {84, 84, 11}, {85, 85, 20}, {86, 86, 21}, {87, 87, 22}, {88, 90, 11}, {91, 96, 2}, {97, 122, 23}, {123, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 32, 1}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {},
            {{0, 33, 24}, {34, 34, 25}, {35, 65535, 24}, },
            {},
            {},
            {{42, 42, 26}, },
            {},
            {{48, 57, 27}, {65, 65, 28}, {66, 66, 29}, {67, 77, 28}, {78, 78, 30}, {79, 82, 28}, {83, 83, 31}, {84, 90, 28}, {95, 95, 32}, {97, 122, 33}, },
            {{48, 57, 27}, {65, 68, 28}, {69, 69, 34}, {70, 90, 28}, {95, 122, -10}, },
            {{48, 57, 27}, {65, 65, 35}, {66, 71, 28}, {72, 72, 36}, {73, 78, 28}, {79, 79, 37}, {80, 90, 28}, {95, 122, -10}, },
            {{48, 57, 27}, {65, 90, 28}, {95, 122, -10}, },
            {{48, 57, 27}, {65, 77, 28}, {78, 78, 38}, {79, 85, 28}, {86, 86, 39}, {87, 90, 28}, {95, 122, -10}, },
            {{48, 57, 27}, {65, 69, 28}, {70, 70, 40}, {71, 76, 28}, {77, 77, 41}, {78, 78, 42}, {79, 90, 28}, {95, 122, -10}, },
            {{48, 68, -11}, {69, 69, 43}, {70, 78, 28}, {79, 79, 44}, {80, 122, -12}, },
            {{48, 57, 27}, {65, 65, 45}, {66, 78, 28}, {79, 79, 46}, {80, 122, -12}, },
            {{48, 57, 27}, {65, 79, 28}, {80, 80, 47}, {81, 90, 28}, {95, 122, -10}, },
            {{48, 57, 27}, {65, 81, 28}, {82, 82, 48}, {83, 90, 28}, {95, 122, -10}, },
            {{48, 68, -11}, {69, 69, 49}, {70, 122, -11}, },
            {{48, 68, -11}, {69, 69, 50}, {70, 88, 28}, {89, 89, 51}, {90, 90, 28}, {95, 122, -10}, },
            {{48, 57, 27}, {65, 82, 28}, {83, 83, 52}, {84, 122, -10}, },
            {{48, 57, 27}, {65, 65, 53}, {66, 90, 28}, {95, 122, -10}, },
            {{48, 57, 27}, {65, 71, 28}, {72, 72, 54}, {73, 90, 28}, {95, 122, -10}, },
            {{48, 122, -13}, },
            {{0, 65535, -5}, },
            {},
            {},
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 55}, {84, 122, -10}, },
            {{48, 57, 27}, {65, 88, 28}, {89, 89, 56}, {90, 122, -21}, },
            {{48, 82, -22}, {83, 83, 57}, {84, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 57, 27}, {65, 70, 28}, {71, 71, 58}, {72, 90, 28}, {95, 122, -10}, },
            {{48, 82, -22}, {83, 83, 59}, {84, 122, -10}, },
            {{48, 57, 27}, {65, 78, 28}, {79, 79, 60}, {80, 122, -12}, },
            {{48, 77, -14}, {78, 78, 61}, {79, 122, -15}, },
            {{48, 57, 27}, {65, 67, 28}, {68, 68, 62}, {69, 90, 28}, {95, 122, -10}, },
            {{48, 68, -11}, {69, 69, 63}, {70, 122, -11}, },
            {{48, 122, -13}, },
            {{48, 79, -18}, {80, 80, 64}, {81, 122, -18}, },
            {{48, 57, 27}, {65, 66, 28}, {67, 67, 65}, {68, 72, 28}, {73, 73, 66}, {74, 85, 28}, {86, 86, 67}, {87, 122, -14}, },
            {{48, 57, 27}, {65, 83, 28}, {84, 84, 68}, {85, 90, 28}, {95, 122, -10}, },
            {{48, 66, -44}, {67, 67, 69}, {68, 90, 28}, {95, 122, -10}, },
            {{48, 66, -44}, {67, 67, 70}, {68, 122, -46}, },
            {{48, 67, -40}, {68, 68, 71}, {69, 122, -40}, },
            {{48, 68, -11}, {69, 69, 72}, {70, 122, -11}, },
            {{48, 68, -11}, {69, 69, 73}, {70, 78, 28}, {79, 79, 74}, {80, 122, -12}, },
            {{48, 69, -15}, {70, 70, 75}, {71, 90, 28}, {95, 122, -10}, },
            {{48, 68, -11}, {69, 69, 76}, {70, 75, 28}, {76, 76, 77}, {77, 83, 28}, {84, 84, 78}, {85, 122, -45}, },
            {{48, 82, -22}, {83, 83, 79}, {84, 122, -10}, },
            {{48, 68, -11}, {69, 69, 80}, {70, 122, -11}, },
            {{48, 57, 27}, {65, 75, 28}, {76, 76, 81}, {77, 81, 28}, {82, 82, 82}, {83, 122, -19}, },
            {{48, 57, 27}, {65, 72, 28}, {73, 73, 83}, {74, 90, 28}, {95, 122, -10}, },
            {{48, 83, -45}, {84, 84, 84}, {85, 122, -45}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 85}, {70, 122, -11}, },
            {{48, 72, -56}, {73, 73, 86}, {74, 122, -56}, },
            {{48, 68, -11}, {69, 69, 87}, {70, 122, -11}, },
            {{48, 72, -56}, {73, 73, 88}, {74, 122, -56}, },
            {{48, 66, -44}, {67, 67, 89}, {68, 82, 28}, {83, 83, 90}, {84, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 77, -14}, {78, 78, 91}, {79, 122, -15}, },
            {{48, 75, -55}, {76, 76, 92}, {77, 78, 28}, {79, 79, 93}, {80, 122, -12}, },
            {{48, 75, -55}, {76, 76, 94}, {77, 90, 28}, {95, 122, -10}, },
            {{48, 83, -45}, {84, 84, 95}, {85, 122, -45}, },
            {{48, 57, 27}, {65, 65, 96}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 57, 27}, {65, 65, 97}, {66, 122, -23}, },
            {{48, 71, -24}, {72, 72, 98}, {73, 122, -24}, },
            {{48, 68, -11}, {69, 69, 99}, {70, 122, -11}, },
            {{48, 81, -19}, {82, 82, 100}, {83, 122, -19}, },
            {{48, 122, -13}, },
            {{48, 57, 27}, {65, 76, 28}, {77, 77, 101}, {78, 79, 28}, {80, 80, 102}, {81, 122, -18}, },
            {{48, 72, -56}, {73, 73, 103}, {74, 122, -56}, },
            {{48, 82, -22}, {83, 83, 104}, {84, 122, -10}, },
            {{48, 68, -11}, {69, 69, 105}, {70, 122, -11}, },
            {{48, 82, -22}, {83, 83, 106}, {84, 122, -10}, },
            {{48, 83, -45}, {84, 84, 107}, {85, 122, -45}, },
            {{48, 82, -22}, {83, 83, 108}, {84, 122, -10}, },
            {{48, 57, 27}, {65, 84, 28}, {85, 85, 109}, {86, 90, 28}, {95, 122, -10}, },
            {{48, 72, -56}, {73, 73, 110}, {74, 122, -56}, },
            {{48, 75, -55}, {76, 76, 111}, {77, 122, -67}, },
            {{48, 81, -19}, {82, 82, 112}, {83, 122, -19}, },
            {{48, 81, -19}, {82, 82, 113}, {83, 122, -19}, },
            {{48, 77, -14}, {78, 78, 114}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 66, -44}, {67, 67, 115}, {68, 122, -46}, },
            {{48, 81, -19}, {82, 82, 116}, {83, 122, -19}, },
            {{48, 83, -45}, {84, 84, 117}, {85, 122, -45}, },
            {{48, 83, -45}, {84, 84, 118}, {85, 122, -45}, },
            {{48, 68, -11}, {69, 69, 119}, {70, 122, -11}, },
            {{48, 81, -19}, {82, 82, 120}, {83, 122, -19}, },
            {{48, 84, -83}, {85, 85, 121}, {86, 122, -83}, },
            {{48, 72, -56}, {73, 73, 122}, {74, 122, -56}, },
            {{48, 81, -19}, {82, 82, 123}, {83, 122, -19}, },
            {{48, 75, -55}, {76, 76, 124}, {77, 122, -67}, },
            {{48, 72, -56}, {73, 73, 125}, {74, 122, -56}, },
            {{48, 75, -55}, {76, 76, 126}, {77, 122, -67}, },
            {{48, 57, 27}, {65, 65, 127}, {66, 122, -23}, },
            {{48, 78, -38}, {79, 79, 128}, {80, 122, -12}, },
            {{48, 68, -11}, {69, 69, 129}, {70, 122, -11}, },
            {{48, 77, -14}, {78, 78, 130}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 66, -44}, {67, 67, 131}, {68, 122, -46}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 132}, {70, 122, -11}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 133}, {70, 122, -11}, },
            {{48, 57, 27}, {65, 65, 134}, {66, 122, -23}, },
            {{48, 68, -11}, {69, 69, 135}, {70, 122, -11}, },
            {{48, 57, 27}, {65, 65, 136}, {66, 122, -23}, },
            {{48, 83, -45}, {84, 84, 137}, {85, 122, -45}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 138}, {70, 122, -11}, },
            {{48, 68, -11}, {69, 69, 139}, {70, 122, -11}, },
            {{48, 57, 27}, {65, 65, 140}, {66, 81, 28}, {82, 82, 141}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 142}, {84, 122, -10}, },
            {{48, 76, -76}, {77, 77, 143}, {78, 90, 28}, {95, 122, -10}, },
            {{48, 83, -45}, {84, 84, 144}, {85, 122, -45}, },
            {{48, 67, -40}, {68, 68, 145}, {69, 122, -40}, },
            {{48, 57, 27}, {65, 65, 146}, {66, 122, -23}, },
            {{48, 72, -56}, {73, 73, 147}, {74, 122, -56}, },
            {{48, 90, -13}, {95, 95, 148}, {97, 122, 33}, },
            {{48, 77, -14}, {78, 78, 149}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 83, -45}, {84, 84, 150}, {85, 122, -45}, },
            {{48, 83, -45}, {84, 84, 151}, {85, 122, -45}, },
            {{48, 81, -19}, {82, 82, 152}, {83, 122, -19}, },
            {{48, 68, -11}, {69, 69, 153}, {70, 122, -11}, },
            {{48, 83, -45}, {84, 84, 154}, {85, 122, -45}, },
            {{48, 76, -76}, {77, 77, 155}, {78, 122, -121}, },
            {{48, 82, -22}, {83, 83, 156}, {84, 122, -10}, },
            {{48, 65, -10}, {66, 66, 157}, {67, 90, 28}, {95, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 66, -44}, {67, 67, 158}, {68, 122, -46}, },
            {{48, 72, -56}, {73, 73, 159}, {74, 122, -56}, },
            {{48, 122, -13}, },
            {{48, 83, -45}, {84, 84, 160}, {85, 122, -45}, },
            {{48, 77, -14}, {78, 78, 161}, {79, 122, -15}, },
            {{48, 57, 27}, {65, 65, 162}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 163}, {70, 122, -11}, },
            {{48, 82, -22}, {83, 83, 164}, {84, 122, -10}, },
            {{48, 68, -11}, {69, 69, 165}, {70, 122, -11}, },
            {{48, 75, -55}, {76, 76, 166}, {77, 122, -67}, },
            {{48, 57, 27}, {65, 65, 167}, {66, 122, -23}, },
            {{48, 78, -38}, {79, 79, 168}, {80, 122, -12}, },
            {{48, 68, -11}, {69, 69, 169}, {70, 122, -11}, },
            {{48, 72, -56}, {73, 73, 170}, {74, 122, -56}, },
            {{48, 68, -11}, {69, 69, 171}, {70, 122, -11}, },
            {{48, 83, -45}, {84, 84, 172}, {85, 122, -45}, },
            {{48, 76, -76}, {77, 77, 173}, {78, 82, 28}, {83, 83, 174}, {84, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 75, -55}, {76, 76, 175}, {77, 122, -67}, },
            {{48, 83, -45}, {84, 84, 176}, {85, 122, -45}, },
            {{48, 78, -38}, {79, 79, 177}, {80, 122, -12}, },
            {{48, 68, -11}, {69, 69, 178}, {70, 122, -11}, },
            {{48, 83, -45}, {84, 84, 179}, {85, 122, -45}, },
            {{48, 72, -56}, {73, 73, 180}, {74, 122, -56}, },
            {{48, 77, -14}, {78, 78, 181}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 182}, {84, 122, -10}, },
            {{48, 72, -56}, {73, 73, 183}, {74, 122, -56}, },
            {{48, 77, -14}, {78, 78, 184}, {79, 122, -15}, },
            {{48, 79, -18}, {80, 80, 185}, {81, 122, -18}, },
            {{48, 122, -13}, },
            {{48, 78, -38}, {79, 79, 186}, {80, 122, -12}, },
            {{48, 82, -22}, {83, 83, 187}, {84, 122, -10}, },
            {{48, 72, -56}, {73, 73, 188}, {74, 122, -56}, },
            {{48, 68, -11}, {69, 69, 189}, {70, 122, -11}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 190}, {70, 122, -11}, },
            {{48, 90, -13}, {95, 95, 191}, {97, 122, 33}, },
            {{48, 77, -14}, {78, 78, 192}, {79, 122, -15}, },
            {{48, 90, -13}, {95, 95, 193}, {97, 122, 33}, },
            {{48, 82, -22}, {83, 83, 194}, {84, 122, -10}, },
            {{48, 77, -14}, {78, 78, 195}, {79, 122, -15}, },
            {{48, 83, -45}, {84, 84, 196}, {85, 122, -45}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 197}, {84, 89, 28}, {90, 90, 198}, {95, 122, -10}, },
            {{48, 83, -45}, {84, 84, 199}, {85, 122, -45}, },
            {{48, 68, -11}, {69, 69, 200}, {70, 122, -11}, },
            {{48, 77, -14}, {78, 78, 201}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 202}, {70, 122, -11}, },
            {{48, 77, -14}, {78, 78, 203}, {79, 122, -15}, },
            {{48, 82, -22}, {83, 83, 204}, {84, 122, -10}, },
            {{48, 66, -44}, {67, 67, 205}, {68, 85, 28}, {86, 86, 206}, {87, 122, -14}, },
            {{48, 82, -22}, {83, 83, 207}, {84, 122, -10}, },
            {{48, 66, -44}, {67, 67, 208}, {68, 85, 28}, {86, 86, 209}, {87, 122, -14}, },
            {{48, 122, -13}, },
            {{48, 83, -45}, {84, 84, 210}, {85, 122, -45}, },
            {{48, 57, 27}, {65, 65, 211}, {66, 122, -23}, },
            {{48, 57, 27}, {65, 65, 212}, {66, 122, -23}, },
            {{48, 57, 27}, {65, 65, 213}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 81, -19}, {82, 82, 214}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 215}, {84, 122, -10}, },
            {{48, 82, -22}, {83, 83, 216}, {84, 122, -10}, },
            {{48, 83, -45}, {84, 84, 217}, {85, 122, -45}, },
            {{48, 122, -13}, },
            {{48, 78, -38}, {79, 79, 218}, {80, 122, -12}, },
            {{48, 57, 27}, {65, 65, 219}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 78, -38}, {79, 79, 220}, {80, 122, -12}, },
            {{48, 57, 27}, {65, 65, 221}, {66, 122, -23}, },
            {{48, 82, -22}, {83, 83, 222}, {84, 122, -10}, },
            {{48, 83, -45}, {84, 84, 223}, {85, 122, -45}, },
            {{48, 83, -45}, {84, 84, 224}, {85, 122, -45}, },
            {{48, 83, -45}, {84, 84, 225}, {85, 122, -45}, },
            {{48, 57, 27}, {65, 65, 226}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 77, -14}, {78, 78, 227}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 228}, {83, 122, -19}, },
            {{48, 77, -14}, {78, 78, 229}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 230}, {83, 122, -19}, },
            {{48, 122, -13}, },
            {{48, 72, -56}, {73, 73, 231}, {74, 122, -56}, },
            {{48, 72, -56}, {73, 73, 232}, {74, 122, -56}, },
            {{48, 72, -56}, {73, 73, 233}, {74, 122, -56}, },
            {{48, 83, -45}, {84, 84, 234}, {85, 122, -45}, },
            {{48, 82, -22}, {83, 83, 235}, {84, 122, -10}, },
            {{48, 72, -56}, {73, 73, 236}, {74, 122, -56}, },
            {{48, 82, -22}, {83, 83, 237}, {84, 122, -10}, },
            {{48, 72, -56}, {73, 73, 238}, {74, 122, -56}, },
            {{48, 78, -38}, {79, 79, 239}, {80, 122, -12}, },
            {{48, 78, -38}, {79, 79, 240}, {80, 122, -12}, },
            {{48, 78, -38}, {79, 79, 241}, {80, 122, -12}, },
            {{48, 72, -56}, {73, 73, 242}, {74, 122, -56}, },
            {{48, 83, -45}, {84, 84, 243}, {85, 122, -45}, },
            {{48, 57, 27}, {65, 65, 244}, {66, 122, -23}, },
            {{48, 83, -45}, {84, 84, 245}, {85, 122, -45}, },
            {{48, 57, 27}, {65, 65, 246}, {66, 122, -23}, },
            {{48, 77, -14}, {78, 78, 247}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 248}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 249}, {79, 122, -15}, },
            {{48, 78, -38}, {79, 79, 250}, {80, 122, -12}, },
            {{48, 57, 27}, {65, 65, 251}, {66, 122, -23}, },
            {{48, 65, -10}, {66, 66, 252}, {67, 122, -136}, },
            {{48, 57, 27}, {65, 65, 253}, {66, 122, -23}, },
            {{48, 65, -10}, {66, 66, 254}, {67, 122, -136}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 77, -14}, {78, 78, 255}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 256}, {79, 122, -15}, },
            {{48, 75, -55}, {76, 76, 257}, {77, 122, -67}, },
            {{48, 77, -14}, {78, 78, 258}, {79, 122, -15}, },
            {{48, 75, -55}, {76, 76, 259}, {77, 122, -67}, },
            {{48, 82, -22}, {83, 83, 260}, {84, 122, -10}, },
            {{48, 83, -45}, {84, 84, 261}, {85, 122, -45}, },
            {{48, 68, -11}, {69, 69, 262}, {70, 122, -11}, },
            {{48, 83, -45}, {84, 84, 263}, {85, 122, -45}, },
            {{48, 68, -11}, {69, 69, 264}, {70, 122, -11}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 265}, {84, 122, -10}, },
            {{48, 82, -22}, {83, 83, 266}, {84, 122, -10}, },
            {{48, 82, -22}, {83, 83, 267}, {84, 122, -10}, },
            {{48, 82, -22}, {83, 83, 268}, {84, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
        }
        { // DEFINITION_FILE
            {{0, 32, 1}, {33, 33, 2}, {34, 34, 3}, {35, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 33, -2}, {35, 65535, -2}, },
            {{0, 33, 2}, {35, 65535, 2}, },
            {},
        }
        { // NO_DEFINITIONS
            {{0, 32, 1}, {33, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 65535, -2}, },
            {{0, 65535, 2}, },
        }
        { // COMMENT
            {{0, 32, 1}, {33, 41, 2}, {42, 42, 3}, {43, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 32, 4}, {127, 160, 4}, {8206, 8207, 4}, {8232, 8233, 4}, },
            {},
            {{47, 47, 5}, },
            {{0, 8233, -3}, },
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // NORMAL
        {-1, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 22, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, 4, -1, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, 7, -1, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, 4, -1, -1, -1, -1, -1, -1, -1, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, -1, -1, -1, -1, -1, -1, -1, -1, 4, -1, -1, -1, -1, 4, -1, -1, -1, -1, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, -1, -1, -1, -1, -1, -1, -1, -1, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, -1, -1, -1, -1, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, -1, -1, -1, -1, -1, 7, -1, -1, -1, -1, -1, -1, 4, -1, -1, -1, -1, -1, 4, -1, -1, -1, -1, 4, -1, -1, -1, 7, -1, -1, -1, -1, -1, -1, 7, -1, -1, 7, -1, -1, 7, -1, -1, 4, -1, -1, -1, -1, -1, -1, -1, -1, 4, 4, 4, -1, -1, 7, -1, -1, -1, -1, 7, -1, -1, -1, -1, 7, 7, -1, -1, -1, -1, -1, 4, 3, -1, -1, -1, -1, -1, -1, -1, -1, 7, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, 4, 4, -1, -1, -1, -1, -1, 7, 7, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, -1, -1, -1, -1, 7, -1, -1, -1, -1, -1, -1, -1, -1, 4, 4, 4, 4, 7, 7, 7, 7, },
        // DEFINITIONS
        {-1, 22, 19, 10, 11, 12, -1, 18, -1, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 0, 13, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 5, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 4, 4, 9, 4, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 4, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 4, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 4, 4, 9, 9, 9, 9, 9, 9, 9, 4, 9, 9, 9, 9, 4, 9, 9, 9, 9, 4, 9, 9, 9, 9, 9, 9, 9, 4, 9, 9, 9, 9, 4, 9, 9, 9, 9, 9, 9, 4, 9, 9, 9, 9, 4, 9, 9, 9, 9, 4, 9, 9, 4, 9, 9, 9, 9, 9, 9, 9, 4, 4, 4, 9, 9, 9, 9, 4, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 4, 4, 4, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 4, 9, 9, 9, 9, 4, 4, 4, 4, },
        // DEFINITIONS_RHS
        {-1, 22, 14, 14, 10, 11, 14, 18, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, -1, 14, 0, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 15, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 15, 17, 17, 17, 17, 17, 16, 17, 17, 17, 17, 17, 15, 17, 17, 17, 17, 15, 17, 17, 17, 17, 17, 17, 17, 17, 15, 17, 17, 17, 17, 15, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 4, 17, 4, 17, 4, 17, 17, 17, 17, 17, 15, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 4, 17, 17, 17, 17, 17, 17, 17, 17, 15, 17, 15, 15, 17, 17, 17, 4, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 15, 4, 4, 17, 17, 17, 17, 17, 17, 17, 4, 17, 17, 17, 17, 4, 17, 17, 17, 17, 4, 17, 17, 17, 17, 17, 17, 17, 4, 17, 17, 17, 17, 4, 17, 17, 17, 17, 17, 17, 4, 17, 17, 17, 17, 4, 17, 17, 17, 17, 4, 17, 17, 4, 17, 17, 17, 17, 17, 17, 17, 4, 4, 4, 17, 17, 17, 17, 4, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 4, 4, 4, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 4, 17, 17, 17, 17, 4, 4, 4, 4, },
        // DEFINITION_FILE
        {20, 20, 20, 19, },
        // NO_DEFINITIONS
        {8, 8, 8, },
        // COMMENT
        {-1, 2, 2, 2, 22, 1, },

    };*/

    public static class State
    {
        public final static State NORMAL = new State(0);
        public final static State DEFINITIONS = new State(1);
        public final static State DEFINITIONS_RHS = new State(2);
        public final static State DEFINITION_FILE = new State(3);
        public final static State NO_DEFINITIONS = new State(4);
        public final static State COMMENT = new State(5);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
